## coturn 4.5.2

=== debian/changelog ===
coturn (4.5.2-3) unstable; urgency=medium

  [ Ferenc Wágner ]
  * [50ab417] Don't rely on the documentation being present for creating the DB.
    Dpkg may be configured to omit installing files under /usr/share/doc.
    Since the database schema is shipped in a private directory as well,
    switch to using that instance instead. (Closes: #985054)
  * [6f94ecb] Let the purge go through under unforeseen circumstances
  * [d8f0a0a] Let debhelper do its business before the final cleanup
  * [4033c69] Make the SQLite database writable by the turnserver user and
    group.
    File permissions alone aren't enough, the containing directory needs to
    be writable as well.
  * [81731d8] Ship the empty /var/lib/turndb directory for better
    discoverability
  * [34a2b34] Split up our autopkgtest into several tests

  [ Mészáros Mihály ]
  * [1666988] Add forwarded not-needed to
    Fix-undefinded-OPENSSL_VERSION_1_1_1.patch

 -- Mészáros Mihály <misi@majd.eu>  Wed, 24 Mar 2021 20:30:23 +0100

coturn (4.5.2-2) unstable; urgency=medium

  [ Michael Prokop ]
  * [059ff0a] debian/coturn.postrm: fix check for dpkg-statoverride on package
    removal. This fixes a regression introduced in commit b9a4a8.
    While at it, also move the statoverride removal before the account removal.
    (Closes: #981330)

  [ Ferenc Wágner ]
  * [e991e26] Enroll to basic Salsa-CI

  [ Mészáros Mihály ]
  * [3505b22] HotFix upstream undefinded OPENSSL_VERSION_1_1_1
  * [20f9a9e] Add tls test to debian autopkgtest

 -- Mészáros Mihály <misi@majd.eu>  Wed, 10 Feb 2021 22:03:27 +0100

coturn (4.5.2-1) unstable; urgency=high

  * [49df393] New upstream release (4.5.2)
    - fix null pointer dereference in case of out of memory.(by Thomas Moeller)
    - merge PR #517 (by wolmi)
      add prometheus metrics
    - merge PR #637 (by David Florness)
      Delete trailing whitespace in example configuration files
    - merge PR #631 (by Debabrata Deka)
      Add architecture ppc64le to travis build
    - merge PR #627 (by Samuel)
      Fix misleading option in doc (prometheus)
    - merge PR #643 (by tupelo-schneck)
      Allow RFC6062 TCP relay data to look like TLS
    - merge PR #655 (by plinss)
      Add support for proxy protocol V1
    - merge PR #618 (by Paul Wayper)
      Print full date and time in logs
      Add new options:
      "new-log-timestamp" and "new-log-timestamp-format"
    - merge PR #599 (by Cédric Krier)
      Do not use FIPS and remove hardcode OPENSSL_VERSION_NUMBER with LibreSSL
    - update Docker mongoDB and fix with workaround the missing systemctl
    - merge PR #660 (by Camden Narzt)
      fix compilation on macOS Big Sur
    - merge PR #546 #551 #672 (by jelmd)
      Add support of --acme-redirect <URL>
      fix acme security, redundancy, consistency
    - Disable binding request logging to avoid DoS attacks.(Breaking change!)
      Add new --log-binding option to enable binding request logging
    - Fix stale-nonce documentation. Resolves #604
    - Version numbering is changed to semver 2.0
    - Merge PR #288 (by Hristo Venev)
      pkg-config, and various cleanups in configure file
    - Add systemd notification for better systemd integration
    - Fix Issue #621 (by ycaibb)
      Null pointer dereference on tcp_client_input_handler_rfc6062data function
    - Fix Issue #600 (by ycaibb)
      use-after-free vulnerability on write_to_peerchannel function
    - Fix Issue #601 (by ycaibb)
      use-after-free vulnerability on write_client_connection function
    - Little refactoring prometheus
      Fix c++ support
      Simplify (as agreed in Issue #666)
      Remove session id/allocation labels
      Remove per session metrics. We should later add more counters.
    - Fix CVE-2020-26262 (credits: Enable-Security)
      Fix ipv6 ::1 loopback check
      Not allow allocate peer address 0.0.0.0/8 and ::/128
      For more details see the github security advisory:
      https://github.com/coturn/coturn/security/advisories/GHSA-6g6j-r9rf-cm7p
  * [f0c1753] Change coturn service type to systemd notify (Closes: #934513)
  * [f9b9547] Add libsystemd-dev to build dependency
  * [5a811b1] Update watch version to 4
  * [c0a645e] Update Debian Standards to 4.5.1
  * [e429100] Patch not-needed to forwarded to upstream
  * [bc56267] Add pkg-config to build dependency
  * [bd98206] Postrm remove dir /var/lib/turn
  * [8c58afe] Change sqlite db permissions.
    Change owner to turnserver:turnserver and mode 660 (Closes: #930097)
  * [b9a4a8b] Change config file permissions.
    Change owner to root:turnserver and mode 640 (Closes: #954379)
  * [3e85092] init.d script drop root privileges (Closes: 904415)
  * [24eb87a] Add info about binding privileged ports (Closes: #964009)
  * [136a8a2] Disable pid file creation

 -- Mészáros Mihály <misi@majd.eu>  Mon, 11 Jan 2021 20:05:38 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

override_dh_auto_install:
	true

override_dh_installexamples:
	dh_installexamples -X ca/CA/ \
		-X ca/turn_client_cert.pem \
		-X ca/turn_client_pkey.pem \
		-X ca/turn_server_cert.pem \
		-X ca/turn_server_pkey.pem

override_dh_installdocs:
	dh_installdocs -X ca/CA/ \
		-X ca/turn_client_cert.pem \
		-X ca/turn_client_pkey.pem \
		-X ca/turn_server_cert.pem \
		-X ca/turn_server_pkey.pem

override_dh_auto_configure:
	dh_auto_configure -- --disable-rpath --turndbdir=/var/lib/turn

%:
	dh $@  --builddirectory=.

=== debian/tests/control ===
Depends: @
Restrictions: needs-root, allow-stderr, isolation-container
Tests: setup, udp, tcp, tls

## coturn 4.6.1

=== CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

cmake_minimum_required(VERSION 3.5)

project(coturn)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
# TODO: Modify this when the version is released
SET(BUILD_VERSION "4.6.1")

# Find Git Version Patch
IF(EXISTS "${CMAKE_SOURCE_DIR}/.git")
    if(NOT GIT)
        SET(GIT $ENV{GIT})
    endif()
    if(NOT GIT)
        FIND_PROGRAM(GIT NAMES git git.exe git.cmd)
    endif()
    IF(GIT)
        EXECUTE_PROCESS(
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            COMMAND ${GIT} describe --tags
            OUTPUT_VARIABLE GIT_VERSION  OUTPUT_STRIP_TRAILING_WHITESPACE
        )
        if(NOT GIT_VERSION)
            EXECUTE_PROCESS(
                WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                COMMAND ${GIT} rev-parse --short HEAD
                OUTPUT_VARIABLE GIT_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE
            )
        endif()
        SET(BUILD_VERSION ${GIT_VERSION})
    ENDIF()
ENDIF()
message("BUILD_VERSION:${BUILD_VERSION}")
set(VERSION ${BUILD_VERSION})

if(NOT DEFINED CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
endif(NOT DEFINED CMAKE_BUILD_TYPE)
string(TOLOWER "${CMAKE_BUILD_TYPE}" build_type)
if("debug" STREQUAL build_type)
    add_definitions(-D_DEBUG)
endif()

IF(MSVC)
    # This option is to enable the /MP switch for Visual Studio 2005 and above compilers
    OPTION(WIN32_USE_MP "Set to ON to build with the /MP option (Visual Studio 2005 and above)." ON)
    MARK_AS_ADVANCED(WIN32_USE_MP)
    IF(WIN32_USE_MP)
        #SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
        add_compile_options(/MP)
    ENDIF(WIN32_USE_MP)
    add_compile_options("$<$<C_COMPILER_ID:MSVC>:/utf-8>")
    add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/utf-8>")
ENDIF(MSVC)

IF(APPLE)
    add_compile_definitions("TURN_NO_THREAD_BARRIERS=1")
ENDIF()

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)
include(GenerateExportHeader)
include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckFunctionExists)

# Create install runtime target
add_custom_target(install-runtime
  COMMAND
     "${CMAKE_COMMAND}" -DCMAKE_INSTALL_COMPONENT=Runtime 
     -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_install.cmake"
)
# Create uninstall runtime target
add_custom_target(uninstall-runtime
  COMMAND
     "${CMAKE_COMMAND}" -DCMAKE_INSTALL_COMPONENT=Runtime 
     -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
)
# Create will be delete files
CONFIGURE_FILE(
    "${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
# Create unistall target
ADD_CUSTOM_TARGET(uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake"
    )

add_subdirectory(src)

install(DIRECTORY man DESTINATION .
    COMPONENT Runtime)
install(DIRECTORY turndb/
    DESTINATION share/turnserver
        COMPONENT Runtime)
install(DIRECTORY turndb/
    DESTINATION doc/turnserver
        COMPONENT Runtime)
install(FILES
            LICENSE
            README.turnserver
            README.turnadmin
            README.turnutils
            INSTALL
            postinstall.txt
        DESTINATION doc/turnserver
            COMPONENT Runtime)
install(FILES examples/etc/turnserver.conf
    DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}
        COMPONENT Runtime
    RENAME turnserver.conf.default
    )
install(DIRECTORY
            examples/etc
            examples/scripts
    DESTINATION share/examples/turnserver
    PATTERN "rfc5769.sh" EXCLUDE
    )

=== src/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

project(coturn)

add_subdirectory(client)
add_subdirectory(server)
add_subdirectory(apps)

=== docker/coturn/Makefile ===
###############################
# Common defaults/definitions #
###############################

comma := ,
empty :=
space := $(empty) $(empty)

# Checks two given strings for equality.
eq = $(if $(or $(1),$(2)),$(and $(findstring $(1),$(2)),\
                                $(findstring $(2),$(1))),1)




######################
# Project parameters #
######################

COTURN_VER ?= 4.6.1
COTURN_MIN_VER = $(strip $(shell echo $(COTURN_VER) | cut -d '.' -f1,2))
COTURN_MAJ_VER = $(strip $(shell echo $(COTURN_VER) | cut -d '.' -f1))

BUILD_REV ?= 0

NAMESPACES := coturn \
              ghcr.io/coturn \
              quay.io/coturn
NAME := coturn
ALL_IMAGES := \
	debian:$(COTURN_VER)-r$(BUILD_REV)-debian,$(COTURN_VER)-debian,$(COTURN_MIN_VER)-debian,$(COTURN_MAJ_VER)-debian,debian,$(COTURN_VER)-r$(BUILD_REV),$(COTURN_VER),$(COTURN_MIN_VER),$(COTURN_MAJ_VER),latest \
	alpine:$(COTURN_VER)-r$(BUILD_REV)-alpine,$(COTURN_VER)-alpine,$(COTURN_MIN_VER)-alpine,$(COTURN_MAJ_VER)-alpine,alpine
#	<Dockerfile>:<version>,<tag1>,<tag2>,...

# Default is first image from ALL_IMAGES list.
DOCKERFILE ?= $(word 1,$(subst :, ,$(word 1,$(ALL_IMAGES))))
TAGS ?= $(word 1,$(subst |, ,\
	$(word 2,!$(subst $(DOCKERFILE):, ,$(subst $(space),|,$(ALL_IMAGES))))))
VERSION ?= $(word 1,$(subst -, ,$(TAGS)))-$(word 2,$(strip \
	$(subst -, ,$(subst $(comma), ,$(TAGS)))))

PLATFORMS ?= linux/amd64 \
             linux/arm64 \
             linux/arm/v6 \
             linux/arm/v7 \
             linux/ppc64le \
             linux/s390x
MAIN_PLATFORM ?= $(word 1,$(subst $(comma), ,$(PLATFORMS)))




###########
# Aliases #
###########

image: docker.image

push: docker.push

release: git.release

test: test.docker




###################
# Docker commands #
###################

docker-namespaces = $(strip $(if $(call eq,$(namespaces),),\
                            $(NAMESPACES),$(subst $(comma), ,$(namespaces))))
docker-tags = $(subst $(comma), ,$(or $(tags),$(TAGS)))
docker-platforms = $(strip $(if $(call eq,$(platforms),),\
                           $(PLATFORMS),$(subst $(comma), ,$(platforms))))

# Runs `docker buildx build` command allowing to customize it for the purpose of
# re-tagging or pushing.
define docker.buildx
	$(eval dockerfile := $(strip $(1)))
	$(eval namespace := $(strip $(2)))
	$(eval tag := $(strip $(3)))
	$(eval git-ref := $(strip $(4)))
	$(eval platform := $(strip $(5)))
	$(eval no-cache := $(strip $(6)))
	$(eval args := $(strip $(7)))
	$(eval github_url := $(strip $(or $(GITHUB_SERVER_URL),https://github.com)))
	$(eval github_repo := $(strip $(or $(GITHUB_REPOSITORY),coturn/coturn)))
	cd ../../ && \
	docker buildx build --force-rm $(args) \
		--platform $(platform) \
		$(if $(call eq,$(no-cache),yes),--no-cache --pull,) \
		$(if $(call eq,$(git-ref),),,--build-arg coturn_git_ref=$(git-ref)) \
		--build-arg coturn_github_url=$(github_url) \
		--build-arg coturn_github_repo=$(github_repo) \
		--label org.opencontainers.image.source=$(github_url)/$(github_repo) \
		--label org.opencontainers.image.revision=$(strip \
			$(shell git show --pretty=format:%H --no-patch)) \
		--label org.opencontainers.image.version=$(subst docker/,,$(strip \
			$(shell git describe --tags --dirty --match='docker/*'))) \
		-f docker/coturn/$(dockerfile)/Dockerfile \
		-t $(namespace)/$(NAME):$(tag) ./
endef


# Pre-build cache for Docker image builds.
#
# WARNING: This command doesn't apply tag to the built Docker image, just
#          creates a build cache. To produce a Docker image with a tag, use
#          `docker.tag` command right after running this one.
#
# Usage:
#	make docker.build.cache [DOCKERFILE=(debian|alpine)]
#		[platforms=($(PLATFORMS)|<platform-1>[,<platform-2>...])]
#		[no-cache=(no|yes)]
#		[ref=<git-ref>]

docker.build.cache:
	$(call docker.buildx,$(DOCKERFILE),\
		coturn,\
		build-cache,\
		$(ref),\
		$(shell echo "$(docker-platforms)" | tr -s '[:blank:]' ','),\
		$(no-cache),\
		--output 'type=image$(comma)push=false')


# Build Docker image on the given platform with the given tag.
#
# Usage:
#	make docker.image [DOCKERFILE=(debian|alpine)]
#		[tag=($(VERSION)|<tag>)]
#		[platform=($(MAIN_PLATFORM)|<platform>)]
#		[no-cache=(no|yes)]
#		[ref=<git-ref>]

docker.image:
	$(call docker.buildx,$(DOCKERFILE),\
		coturn,\
		$(or $(tag),$(VERSION)),\
		$(ref),\
		$(or $(platform),$(MAIN_PLATFORM)),\
		$(no-cache),\
		--load)


# Push Docker images to their repositories (container registries),
# along with the required multi-arch manifests.
#
# Usage:
#	make docker.push [DOCKERFILE=(debian|alpine)]
#		[namespaces=($(NAMESPACES)|<prefix-1>[,<prefix-2>...])]
#		[tags=($(TAGS)|<tag-1>[,<tag-2>...])]
#		[platforms=($(PLATFORMS)|<platform-1>[,<platform-2>...])]
#		[ref=<git-ref>]

docker.push:
	$(foreach namespace,$(docker-namespaces),\
		$(foreach tag,$(docker-tags),\
			$(call docker.buildx,$(DOCKERFILE),\
				$(namespace),\
				$(tag),\
				$(ref),\
				$(shell echo "$(docker-platforms)" | tr -s '[:blank:]' ','),,\
				--push)))




####################
# Testing commands #
####################

# Run Bats tests for Docker image.
#
# Documentation of Bats:
#	https://github.com/bats-core/bats-core
#
# Usage:
#	make test.docker
#		[tag=($(VERSION)|<tag>)]
#		[platforms=($(MAIN_PLATFORM)|@all|<platform-1>[,<platform-2>...])]
#		[( [build=no]
#		 | build=yes [DOCKERFILE=(debian|alpine)]
#		             [ref=<git-ref>] )]
#		[with=ipv6]

test-docker-platforms = $(strip $(if $(call eq,$(platforms),),$(MAIN_PLATFORM),\
                                $(if $(call eq,$(platforms),@all),$(PLATFORMS),\
                                $(docker-platforms))))
test.docker:
ifeq ($(wildcard node_modules/.bin/bats),)
	@make npm.install
endif
	$(foreach platform,$(test-docker-platforms),\
		$(call test.docker.do,$(or $(tag),$(VERSION)),$(platform)))
define test.docker.do
	$(eval tag := $(strip $(1)))
	$(eval platform := $(strip $(2)))
	$(if $(call eq,$(build),yes),\
		@make docker.image DOCKERFILE=$(DOCKERFILE) \
			no-cache=no tag=$(tag) platform=$(platform) ref=$(ref) ,)
	IMAGE=coturn/$(NAME):$(tag) PLATFORM=$(platform) \
	$(if $(call eq,$(with),ipv6),TEST_IPV6=1,) \
	node_modules/.bin/bats \
		--timing $(if $(call eq,$(CI),),--pretty,--formatter tap) \
		tests/main.bats
endef




################
# NPM commands #
################

# Resolve project NPM dependencies.
#
# Usage:
#	make npm.install [dockerized=(no|yes)]

npm.install:
ifeq ($(dockerized),yes)
	docker run --rm --network=host -v "$(PWD)":/app/ -w /app/ \
		node \
			make npm.install dockerized=no
else
	npm install
endif




################
# Git commands #
################

# Release project version (apply version tag and push).
#
# Usage:
#	make git.release [ver=($(VERSION)|<proj-ver>)]

git-release-tag = docker/$(strip $(or $(ver),$(VERSION)))

git.release:
ifeq ($(shell git rev-parse $(git-release-tag) >/dev/null 2>&1 && echo "ok"),ok)
	$(error "Git tag $(git-release-tag) already exists")
endif
	git tag $(git-release-tag)
	git push origin refs/tags/$(git-release-tag)




##################
# .PHONY section #
##################

.PHONY: image push release test \
        docker.build.cache docker.image docker.push \
        git.release \
        npm.install \
        test.docker

=== src/apps/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

add_subdirectory(common)
add_subdirectory(natdiscovery)
add_subdirectory(oauth)
add_subdirectory(peer)
add_subdirectory(relay)
add_subdirectory(rfc5769)
add_subdirectory(stunclient)
add_subdirectory(uclient)

=== src/server/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

project(turn_server)

set(SOURCE_FILES
    ns_turn_allocation.c
    ns_turn_maps_rtcp.c
    ns_turn_maps.c
    ns_turn_server.c
    )

set(HEADER_FILES
    ns_turn_allocation.h
    ns_turn_ioalib.h
    ns_turn_khash.h
    ns_turn_maps_rtcp.h
    ns_turn_maps.h
    ns_turn_server.h
    ns_turn_session.h
    )

add_library(${PROJECT_NAME} ${SOURCE_FILES} ${HEADER_FILES})

target_link_libraries(${PROJECT_NAME} PUBLIC turnclient)

# See: http://www.it1352.com/478094.html
target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    )

# Install head files
set_target_properties(${PROJECT_NAME} PROPERTIES
    VERSION ${VERSION}
    )

INSTALL(TARGETS ${PROJECT_NAME}
    EXPORT ${PROJECT_NAME}Config
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        COMPONENT Runtime
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        COMPONENT Runtime
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    INCLUDES DESTINATION
        ${CMAKE_INSTALL_INCLUDEDIR}
        ${CMAKE_INSTALL_INCLUDEDIR}/turn
        ${CMAKE_INSTALL_INCLUDEDIR}/turn/client
    )

export(TARGETS ${PROJECT_NAME}
    APPEND FILE ${CMAKE_BINARY_DIR}/${PROJECT_NAME}Config.cmake
    )

# Install cmake configure files
install(EXPORT ${PROJECT_NAME}Config
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake"
    )
# Install cmake version configure file
if(DEFINED VERSION)
    write_basic_package_version_file(
        "${CMAKE_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
        VERSION ${VERSION}
        COMPATIBILITY AnyNewerVersion)
    install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake")
endif()

=== src/apps/common/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

project(turncommon)

set(SOURCE_FILES
    apputils.c
    ns_turn_utils.c
    stun_buffer.c
    )

set(HEADER_FILES
    apputils.h
    ns_turn_openssl.h
    ns_turn_utils.h
    stun_buffer.h
    )

if(NOT WIN32)
    set(COMMON_LIBS pthread)
endif()
set(libevent_components core extra openssl)
if(NOT WIN32)
    list(APPEND libevent_components pthreads)
endif()
find_package(Libevent COMPONENTS ${libevent_components})
if(Libevent_FOUND)
    foreach(_libevent_com ${libevent_components})
        list(APPEND COMMON_LIBS Libevent::${_libevent_com})
    endforeach()
endif()

find_package(hiredis)
if(hiredis_FOUND)
    list(APPEND SOURCE_FILES hiredis_libevent2.c)
    list(APPEND HEADER_FILES hiredis_libevent2.h)
    list(APPEND COMMON_LIBS hiredis::hiredis)
else()
    list(APPEND COMMON_DEFINED TURN_NO_HIREDIS)
endif()

find_package(OpenSSL REQUIRED Crypto SSL)
list(APPEND COMMON_LIBS OpenSSL::Crypto)
list(APPEND COMMON_LIBS OpenSSL::SSL)

message("COMMON_LIBS:${COMMON_LIBS}")

add_library(${PROJECT_NAME} ${SOURCE_FILES} ${HEADER_FILES})

target_link_libraries(${PROJECT_NAME} PUBLIC ${COMMON_LIBS})
target_compile_definitions(${PROJECT_NAME} PUBLIC ${COMMON_DEFINED})
target_compile_options(${PROJECT_NAME} PUBLIC -Wno-deprecated-declarations)

# See: http://www.it1352.com/478094.html
target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/server>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/client>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/apps/common>
    ${COMMON_INCLUDE_DIR}
    )

# Install head files
set_target_properties(${PROJECT_NAME} PROPERTIES
    VERSION ${VERSION}
    )

INSTALL(TARGETS ${PROJECT_NAME}
    EXPORT ${PROJECT_NAME}Config
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        COMPONENT Runtime
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        COMPONENT Runtime
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    INCLUDES DESTINATION
        ${CMAKE_INSTALL_INCLUDEDIR}
        ${CMAKE_INSTALL_INCLUDEDIR}/turn
        ${CMAKE_INSTALL_INCLUDEDIR}/turn/client
    )

export(TARGETS ${PROJECT_NAME}
    APPEND FILE ${CMAKE_BINARY_DIR}/${PROJECT_NAME}Config.cmake
    )

# Install cmake configure files
install(EXPORT ${PROJECT_NAME}Config
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake"
    )
# Install cmake version configure file
if(DEFINED VERSION)
    write_basic_package_version_file(
        "${CMAKE_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
        VERSION ${VERSION}
        COMPATIBILITY AnyNewerVersion)
    install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake")
endif()

=== src/apps/natdiscovery/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

project(turnutils_natdiscovery)

set(SOURCE_FILES
    natdiscovery.c
    )

add_executable(${PROJECT_NAME} ${SOURCE_FILES})
target_link_libraries(${PROJECT_NAME} PRIVATE turnclient)
INSTALL(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        COMPONENT Runtime
    )

=== src/apps/oauth/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

project(turnutils_oauth)

set(SOURCE_FILES
    oauth.c
    )

add_executable(${PROJECT_NAME} ${SOURCE_FILES})
target_link_libraries(${PROJECT_NAME} PRIVATE turnclient)
INSTALL(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        COMPONENT Runtime
    )

=== src/apps/peer/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

project(turnutils_peer)

set(SOURCE_FILES
    mainudpserver.c udpserver.c
    )

add_executable(${PROJECT_NAME} ${SOURCE_FILES})
target_link_libraries(${PROJECT_NAME} PRIVATE turnclient)
INSTALL(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        COMPONENT Runtime
    )

=== src/apps/relay/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

project(turnserver)

set(HEAD_FILES
    tls_listener.h
    mainrelay.h
    turn_admin_server.h
    dtls_listener.h
    libtelnet.h
    ns_ioalib_impl.h
    ns_sm.h
    turn_ports.h
    userdb.h
    dbdrivers/dbdriver.h
    )

set(SOURCE_FILES
    mainrelay.c
    netengine.c
    libtelnet.c
    turn_admin_server.c
    tls_listener.c
    dtls_listener.c
    ns_ioalib_engine_impl.c
    turn_ports.c
    http_server.c
    acme.c
    userdb.c
    dbdrivers/dbdriver.c
    )

find_package(SQLite)
if(SQLite_FOUND)
    list(APPEND turnserver_LIBS SQLite::sqlite)
    list(APPEND SOURCE_FILES dbdrivers/dbd_sqlite.c)
    list(APPEND HEAD_FILES dbdrivers/dbd_sqlite.h)
else()
    list(APPEND turnserver_DEFINED TURN_NO_SQLITE)
endif()

find_package(PostgreSQL)
if(PostgreSQL_FOUND)
    list(APPEND turnserver_LIBS PostgreSQL::pq)
    list(APPEND SOURCE_FILES dbdrivers/dbd_pgsql.c)
    list(APPEND HEAD_FILES dbdrivers/dbd_pgsql.h)
else()
    list(APPEND turnserver_DEFINED TURN_NO_PQ)
endif()

find_package(MySQL)
if(MySQL_FOUND)
    list(APPEND turnserver_LIBS MySQL::mysql)
    list(APPEND SOURCE_FILES dbdrivers/dbd_mysql.c)
    list(APPEND HEAD_FILES dbdrivers/dbd_mysql.h)
else()
    list(APPEND turnserver_DEFINED TURN_NO_MYSQL)
endif()

find_package(mongo)
if(mongo_FOUND)
    list(APPEND turnserver_LIBS mongo)
    list(APPEND SOURCE_FILES dbdrivers/dbd_mongo.c)
    list(APPEND HEAD_FILES dbdrivers/dbd_mongo.h)
else()
    list(APPEND turnserver_DEFINED TURN_NO_MONGO)
endif()

find_package(hiredis)
if(hiredis_FOUND)
    list(APPEND turnserver_LIBS hiredis::hiredis)
    list(APPEND SOURCE_FILES dbdrivers/dbd_redis.c)
    list(APPEND HEAD_FILES dbdrivers/dbd_redis.h)
else()
    list(APPEND turnserver_DEFINED TURN_NO_HIREDIS)
endif()

if(NOT APPLE)
    find_package(libsystemd)
    if(libsystemd_FOUND)
    else()
        list(APPEND turnserver_DEFINED TURN_NO_SYSTEMD)
    endif()
else()
    list(APPEND turnserver_DEFINED TURN_NO_SYSTEMD)
endif()

find_package(Prometheus)
if(Prometheus_FOUND)
    list(APPEND SOURCE_FILES prom_server.c)
    list(APPEND HEAD_FILES prom_server.h)
else()
    list(APPEND turnserver_DEFINED TURN_NO_PROMETHEUS)
endif()

add_executable(${PROJECT_NAME} ${SOURCE_FILES} ${HEAD_FILES})
target_link_libraries(${PROJECT_NAME} PRIVATE turn_server ${turnserver_LIBS})
target_include_directories(${PROJECT_NAME} PRIVATE ${turnserver_include_dirs})
target_compile_definitions(${PROJECT_NAME} PRIVATE ${turnserver_DEFINED})

add_custom_target(turnadmin ALL
    COMMAND 
        ${CMAKE_COMMAND} -E create_symlink $<TARGET_FILE_NAME:${PROJECT_NAME}> turnadmin
    DEPENDS ${PROJECT_NAME})

INSTALL(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        COMPONENT Runtime
    )

INSTALL(FILES $<TARGET_FILE_DIR:${PROJECT_NAME}>/turnadmin
    DESTINATION "${CMAKE_INSTALL_BINDIR}"
            COMPONENT Runtime)

=== src/apps/rfc5769/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

project(turnutils_rfc5769check)

set(SOURCE_FILES
    rfc5769check.c
    )

add_executable(${PROJECT_NAME} ${SOURCE_FILES})
target_link_libraries(${PROJECT_NAME} PRIVATE turnclient)
INSTALL(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        COMPONENT Runtime
    )

=== src/apps/stunclient/CMakeLists.txt ===
# Author: Kang Lin (kl222@126.com)

project(turnutils_stunclient)

set(SOURCE_FILES
    stunclient.c
    )

add_executable(${PROJECT_NAME} ${SOURCE_FILES})
target_link_libraries(${PROJECT_NAME} PRIVATE turnclient)
INSTALL(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        COMPONENT Runtime
    )

=== debian/changelog ===
coturn (4.6.1-2build1) plucky; urgency=medium

  * No-change rebuild against mysql-8.4 and libmysqlclient24 (LP: #2089059)

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 05 Feb 2025 15:44:18 -0500

coturn (4.6.1-2) unstable; urgency=medium

  * Team upload
  * [72b4051] gbp: Remove DEFAULT rules
  * [e8cd8e1] Use common VoIP Team name
  * [5c6af2b] Link to common team Vcs (Closes: #960919)
  * [115af22] Drop default CI config
  * [f63dcdf] Fix lintian: depends-on-obsolete-package
  * [062f3bf] Drop useless lintian overrides
  * [22048fc] d/copyright: clean up

 -- Bastian Germann <bage@debian.org>  Sat, 13 Apr 2024 13:50:36 +0000

coturn (4.6.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Dominik George <natureshadow@debian.org>  Sun, 05 Feb 2023 11:03:55 +0100

coturn (4.5.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * [518094e] New No-FIPS-140-mode.patch fixes build against OpenSSL 3.0
    (Closes: #995659, LP: #1967018)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Thu, 02 Jun 2022 13:36:34 +0300

=== debian/control ===
Source: coturn
Section: net
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Oleg Moskalenko <mom040267@gmail.com>,
           Mészáros Mihály <misi@majd.eu>
Build-Depends: debhelper-compat (= 13),
               default-libmysqlclient-dev,
               default-mysql-client,
               dpkg-dev (>= 1.16.1~),
               libsystemd-dev [linux-any],
               pkgconf,
               libevent-dev (>= 2.0.1~),
               libhiredis-dev,
               libpq-dev,
               libsqlite3-dev,
               libssl-dev (>= 1.0.0~),
               postgresql-client,
               sqlite3
Standards-Version: 4.5.1
Homepage: https://github.com/coturn/coturn/
Vcs-Git: https://salsa.debian.org/pkg-voip-team/coturn.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/coturn
Rules-Requires-Root: no

Package: coturn
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser,
         sqlite3,
         telnet | telnet-client,
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: rfc5766-turn-server,
           turnserver
Suggests: sip-router,
          xmpp-server
Provides: stun-server,
          turn-server
Description: TURN and STUN server for VoIP
 STUN (Session Traversal Utilities for NAT) and TURN (Traversal Using Relays
 around NAT) are protocols that can be used to provide NAT traversal for VoIP
 and WebRTC. This package provides a VoIP media traffic NAT traversal server
 and gateway.
 .
 Supported RFCs:
 TURN specs:
  * RFC 5766 - base TURN specs;
  * RFC 6062 - TCP relaying TURN extension;
  * RFC 6156 - IPv6 extension for TURN;
  * RFC 7635 - OAuth third-party TURN/STUN authorization;
  * DTLS support as client protocol
    http://tools.ietf.org/html/draft-petithuguenin-tram-turn-dtls-00
  * Mobile ICE (MICE) support
    http://tools.ietf.org/html/draft-wing-tram-turn-mobility-03
  * TURN ORIGIN specs for multi-tenant servers
    http://tools.ietf.org/html/draft-johnston-tram-stun-origin-02
  * TURN Bandwidth draft specs
    http://tools.ietf.org/html/draft-thomson-tram-turn-bandwidth-00
  * SSODA (dual allocation) draft specs
    http://tools.ietf.org/html/draft-martinsen-tram-ssoda-00
 .
 STUN specs:
  * RFC 3489 - obsolete "classic" STUN specs;
  * RFC 5389 - base "new" STUN specs;
  * RFC 5769 - test vectors for STUN protocol testing;
  * RFC 5780 - NAT behavior discovery support.
 .
 The implementation fully supports UDP, TCP, TLS, and DTLS as protocols between
 the TURN client and the TURN server. Both UDP and TCP relaying are supported.
 .
 SQLite, MySQL, PostgreSQL and Redis are supported for the user
 repository (if authentication is required).
 The long-term credentials mechanism is supported.
 For WebRTC applications,
 the TURN server REST API for time-limited
 secret-based authentication is implemented.
 The third-party authentication
 specs (OAuth-based) are supported, too.
 .
 Load balancing can be implemented either by DNS round-robin mechanism, or with
 the external networking tools, or by
 the built-in ALTERNATE-SERVER mechanism.
 .
 The implementation is intended to be simple to install and configure.
 The project focuses on performance, scalability, and simplicity.
 The aim is to provide an enterprise-grade TURN solution.
